<?php
/**
 * this class is in charge of loading/saving the config from wordpress
 */

class EPConfig
{

	/**
	 * content of the project array
	 */
	var $projectArray;

	/**
	 * content of the version array
	 * each element is an array of versions, e.g. $versionArray[1] could be array("v1.3","v1.4","v1.6")
	 * each element corresponds to the element of $projectArray at the same indice
	 */
	var $versionArray;
	
	var $epAllowedFoldersArray;
	var $epSecureOfflineFolderDir;
	
	/**
	 * load config from wordpress config
	 * fill up the projects and versions arrays
	 */
	function loadConfig() {
		// get the list of projects
		$this->projectArray = get_option("projectArray");
		if ($this->projectArray == '')
			$this->projectArray = Array();

		// get the list of versions
		$versionArray = get_option("versionArray");
		if ($versionArray == '')
			$versionArray = Array();
		
		// fill the versions array
		$this->versionArray = array();
		for($idx=0;$idx<count($versionArray);$idx++)
		{
			$this->versionArray[] = explode(',',$versionArray[$idx]);
		}
		
		$this->epSecureOfflineFolderDir = get_option("epSecureOfflineFolderDir");
		$this->epAllowedFoldersArray = get_option("epAllowedFoldersArray");
	}
	
	/**
	 * saves in WP options the projects and versions arrays
	 */
	function saveConfig() {
		update_option("projectArray",$this->projectArray);
		
		$versionArray = array();
		for($idx=0;$idx<count($this->versionArray);$idx++)
		{
			$versionArray[] = implode(',',$this->versionArray[$idx]);
		}
		update_option("versionArray",$versionArray);

		update_option("epSecureOfflineFolderDir",$this->epSecureOfflineFolderDir);
		update_option("epAllowedFoldersArray",$this->epAllowedFoldersArray);
	}
}
?>