<?php
/*  Copyright 2009  Alexandre Hoyau  (email : lex [at] silex-ria . org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/**
 * @package exchange-platform
 * @author http://lex.silex.tv/
 * @version 1
 */
require_once(EP_PLUGIN_DIR.'/includes/version_editor.php');
/**
 * class used to manage the upload and all the process of unzip etc
 * For the upload : Use the upload script of the pdf import Silex plugin
 * For the unzip and generation of the version.xml file : Zabojad handle this, the code is in the updater Silex  plugin
 */
class EPItemFiles
{
	var $ALLOWED_EXTENSIONS = array('zip');
	var $MAX_FILE_SIZE = 250000000;
	/**
	 * 
	 */
	static function getDownloadFileUrl($idPostWordpress)
	{
		return EP_ONLINE_DOWNLOADS_URL.'/'.$idPostWordpress.'/download.zip';
	}
	/**
	 * 
	 */
	static function getItemFolderPath($epSecureOfflineFolderDir, $idPostWordpress)
	{
		return $epSecureOfflineFolderDir . '/' . $idPostWordpress;
	}
	/**
	 * 
	 */
	static function getDownloadFilePath($idPostWordpress)
	{
		return EP_ONLINE_DOWNLOADS_DIR . '/' . $idPostWordpress . '/download.zip';
	}
	/**
	 * security check
	 * unzip into EP_SECURE_OFFLINE_FOLDER_PATH
	 * generate version.xml
	 * regenerate zip with version.xml EP_ONLINE_DOWNLOADS_DIR
	 * @return error message or ''
	 */
	function handleUploadedFile($uploadedFileObject, $epSecureOfflineFolderDir, $allowedFoldersArray, $versionInfo, $idPostWordpress)
	{
		global $wp_filesystem;
		
		// If file has a valid extension
		if($this->isAllowedExtension($uploadedFileObject['name'])) 
		{
			if (!isset($wp_filesystem))
			{
				WP_Filesystem();
				if (!isset($wp_filesystem))
				{
					error_log('Could not initialize FILESYSTEM OBJECT');
					//throw (new Exception('Could not initialize FILESYSTEM OBJECT'));
					return 'Could not initialize FILESYSTEM OBJECT';
				}
			}
			// move to temp folder with the same name
			$tempZipFilePath = EP_TEMP_DIR . '/' . basename($uploadedFileObject['tmp_name']);
			$wp_filesystem->chmod(EP_TEMP_DIR.'/',0755);
			move_uploaded_file($uploadedFileObject['tmp_name'], $tempZipFilePath);
			if (!file_exists($tempZipFilePath))
			{
				// error
				error_log('File could not be moved from '.$uploadedFileObject['tmp_name'].', to '.$tempZipFilePath);
				//throw (new Exception('File could not be moved from '.$uploadedFileObject['tmp_name'].', to '.$tempZipFilePath));
				return 'File could not be moved from '.$uploadedFileObject['tmp_name'].', to '.$tempZipFilePath;
			}
			// unzip with temp name
			$tempFolderPath = EP_TEMP_DIR . '/' . basename($uploadedFileObject['tmp_name']) . '_unzipped'; 
			$result = unzip_file($tempZipFilePath, $tempFolderPath);
			if (is_wp_error($result))
			{
				$wp_filesystem->delete($tempFolderPath,true);
				$wp_filesystem->delete($tempZipFilePath);
				error_log("Could not unzip $tempZipFilePath to $tempFolderPath ".$result->get_error_message());
				//throw new Exception("Could not unzip $tempZipFilePath to $tempFolderPath");
				return "Could not unzip $tempZipFilePath to $tempFolderPath";
			}
			// delete the initial zip file
			// keep it and make it available for downloads: $wp_filesystem->delete($tempZipFilePath);

			// **
			// process the unzipped archive
			$firstLevelDir = $tempFolderPath;
			$errorMessage = $this->processUnzippedFolder($firstLevelDir,$allowedFoldersArray,$versionInfo,$idPostWordpress);
			if ( $errorMessage !== '')
			{
				$wp_filesystem->delete($tempFolderPath,true);
				// generate an eror "File could not be moved from..."
					// $wp_filesystem->delete($tempZipFilePath);
				//throw new Exception($errorMessage);
				return $errorMessage;
			}
			// check the upload dir
			if (!is_dir(EP_ONLINE_DOWNLOADS_DIR))
				mkdir(EP_ONLINE_DOWNLOADS_DIR);
/*			// regenerate zip into EP_ONLINE_DOWNLOADS_DIR with temp name
			$this->zip($tempFolderPath, $tempZipFilePath);
			if (count($errors)>0)
			{
				error_log("Could not zip $tempFolderPath to $tempZipFilePath");
				throw new Exception("Could not unzip $tempZipFilePath to $tempFolderPath");
				return false;
			}
			*/
			// **
			// success => let's replace the old files
			// **
			// compute final path
			$finalSecurePath = $epSecureOfflineFolderDir . '/' . $idPostWordpress;
			$finalOnlinePath = EP_ONLINE_DOWNLOADS_DIR . '/' . $idPostWordpress . '/download.zip';
			$wp_filesystem->chmod($finalSecurePath.'/',0755);
			$wp_filesystem->chmod($finalOnlinePath.'/',0755);
			
			// If destination file already exists, remove it
			if(file_exists($finalSecurePath)) 
			{
				error_log("Info: deleting $finalSecurePath");
				$wp_filesystem->delete($finalSecurePath,true);
			}
			// If destination file already exists, remove it
			if(file_exists($finalOnlinePath)) 
			{
				error_log("Info: deleting $finalOnlinePath");
				$wp_filesystem->delete($finalOnlinePath,true);
			}
			// create dir
			$onlineDir = EP_ONLINE_DOWNLOADS_DIR . '/' . $idPostWordpress;
			if (is_dir($onlineDir))
			{
				$wp_filesystem->delete($onlineDir,true);
			}

			// move zip file
			$onlineDir = EP_ONLINE_DOWNLOADS_DIR . '/' . $idPostWordpress;
			mkdir($onlineDir);
			$wp_filesystem->chmod($onlineDir,0755);
			// generate the error "File could not be moved from C:\Program Files (x86)\wamp\tmp\phpD8F9.tmp, to C:\Users\lexa\Documents\repositories\exchange platform\wordpress/wp-content/plugins/exchange-platform/temp/phpD8F9.tmp"
			//rename($tempZipFilePath, $finalOnlinePath); //////////////////////////////
			
			copy($tempZipFilePath, $finalOnlinePath); //////////////////////////////
			// generate the error "File could not be moved from C:\Program Files (x86)\wamp\tmp\phpD8F9.tmp, to C:\Users\lexa\Documents\repositories\exchange platform\wordpress/wp-content/plugins/exchange-platform/temp/phpD8F9.tmp"
			//$wp_filesystem->delete($tempZipFilePath,true);
			
			// move folder
			$wp_filesystem->move($firstLevelDir, $finalSecurePath);
			
			
			// remove top level directory if needed
			if (is_dir($tempFolderPath))
				$wp_filesystem->delete($tempFolderPath,true);
		}
		else
		{
			error_log('Bad file extension');
			// throw new Exception('Bad file extension');
			return 'Bad file extension';
		}
		
		return '';
	}
	/**
	 * check if files are allowed
	 * remove the top level folder if needed
	 * generate version.xml
	 * $unzippedFolder is passed by adress because it may be modifyed if we think that the archive root is one level under
	 * @return error message or ''
	 */
	function processUnzippedFolder(&$unzippedFolder,$allowedFoldersArray,$versionInfo,$idPostWordpress)
	{
		// **
		// check that there is only one top level folder
		// remember the last folder we see, in order to remove 1st level folder			
		$okFiles = array();
		$koFiles = array();
		$tryToRemoveRootFolder = false;
		$loopsCount = 0;
		$rootOfArchive=$unzippedFolder;
		do
		{
			if (($handle = opendir($rootOfArchive))) 
			{
				while ($file = readdir($handle)) 
				{
					if ($file !== '.' && $file !== '..' && $file !== '.DS_Store' && $file !== 'Thumbs.db' && $file !== '.svn' )
					{
						$numFolders++;
						if (is_dir($rootOfArchive.'/'.$file) == true && $this->checkFolderIsAllowed($file,$allowedFoldersArray) === true)
							$okFiles[] = $file;
						else
							$koFiles[] = $file;
					}
				}
				closeDir($handle);
			}
			// try to look inside the folder if it is a single folder containing the archive
			if ($tryToRemoveRootFolder == false && count($okFiles) == 0 && count($koFiles) == 1)
			{
				$tryToRemoveRootFolder = true;
				$rootOfArchive = $rootOfArchive.'/'.$koFiles[0];
				// reset counters
				$okFiles = array();
				$koFiles = array();
			}
			else
			{
				$tryToRemoveRootFolder = false;
			}
		}
		while($tryToRemoveRootFolder == true && $loopsCount++<1);
		
		// empty archive
		if ( count($okFiles) + count($koFiles) <= 0)
		{
			return 'zip file is empty <br /> ';//.$rootOfArchive;//.$loopsCount.' b '.$rootOfArchive.' c '.print_r($koFiles,true).' d '.print_r($koFiles,true). ' e '.print_r($allowedFoldersArray,true);
		}
		if (count($koFiles)>0)
		{
			$message = 'these files are not allowed at the root of the zip file: <ul><li> - '.implode('</li><li> - ',$koFiles).'</li></ul><br />Instead, these ones are expected (at least one of these):<ul><li> - '.implode('</li><li> - ',$allowedFoldersArray).'</li></ul>';
			return $message;
		}
		// here, the archive root is probably good
		$unzippedFolder = $rootOfArchive;
		// generate version.xml
		if (!$this->generateVersionXML($rootOfArchive,$versionInfo,$idPostWordpress))
		{
			return 'Could not generate version.xml file for folder '.$unzippedFolder;
		}
		return '';
	}
	/**
	 * check if the path is allowed according to the allowedFoldersArray parameter
	 * @return true if the path is allowed
	 */
	function checkFolderIsAllowed($folderPath,$allowedFoldersArray)
	{
		for ($idx=0;$idx<count($allowedFoldersArray);$idx++)
		{
			$allowedPath = $allowedFoldersArray[$idx];
			if (strpos($folderPath,$allowedPath) === 0)
				return true;
		}
		return false;
	}
	/**
	 * generate a version.xml file for the given folder. It uses Silex version generator class
	 * @return true for success
	 */
	function generateVersionXML($folderPath,$versionInfo,$idPostWordpress)
	{
		$mySilexElement = SilexElement::createFromFileTree($folderPath,$idPostWordpress);
		if ($mySilexElement === FALSE)
			return FALSE;
		$mySilexElement->compatibleVersions = $versionInfo['compatibleVersions'];
		$mySilexElement->saveVersion($folderPath.'/version.xml',true);
		
		// save dependencies to post metadata
		$epItemData = new EPItemData();
		$epItemData->setDependencies($mySilexElement->dependencies,$idPostWordpress);
		//$epItemData->setDependencies(array('xxx','yyy'),$versionInfo['postID']);
		
		return true;
	}
	/** 
	 * remove files for a ginven post
	 * @return error message or '' 
	 */
	function removeFiles($epSecureOfflineFolderDir,$postID) 
	{
		global $wp_filesystem;
		
		if (!isset($wp_filesystem))
		{
			WP_Filesystem();
			if (!isset($wp_filesystem))
			{
				error_log('Could not initialize FILESYSTEM OBJECT');
				//throw (new Exception('Could not initialize FILESYSTEM OBJECT'));
				return 'Could not initialize FILESYSTEM OBJECT';
			}
		}
		$onlineDir = EP_ONLINE_DOWNLOADS_DIR . '/' . $postID . '/';
		$wp_filesystem->delete($onlineDir,true);
		$finalSecurePath = $epSecureOfflineFolderDir . '/' . $postID . '/';
		$wp_filesystem->delete($finalSecurePath,true);
		EPDataBase::initDB();
		EPDataBase::removeAllFiles($postID);
		return '';
	}
	/** 
	 * create directory
	 */
	function mkdirr($pn,$mode=null) 
	{	
		if(is_dir($pn)||empty($pn)) return true;
		$pn=str_replace(array('/', ''),DIRECTORY_SEPARATOR,$pn);
		
		if(is_file($pn)) {trigger_error('mkdirr() File exists', E_USER_WARNING);return false;}
		
		$next_pathname=substr($pn,0,strrpos($pn,DIRECTORY_SEPARATOR));
		if(mkdirr($next_pathname,$mode)) {if(!file_exists($pn)) {return mkdir($pn,$mode);} }
		return false;
	}	
	/**
	 * Checks if extension is valid 
	 */
	function isAllowedExtension($fileName) 
	{
		return in_array(end(explode(".", strtolower($fileName))), $this->ALLOWED_EXTENSIONS);
	}
	/**
	 * Handles upload error message if any
	 */
	function file_upload_error_message($error_code) {
	    switch ($error_code) {
	        case UPLOAD_ERR_INI_SIZE:
	            return 'File exceeds upload_max_filesize value ('.ini_get('upload_max_filesize').') in php.ini or .htaccess';
	        case UPLOAD_ERR_FORM_SIZE:
	            return 'File exceeds the MAX_FILE_SIZE value ('.display_filesize($_POST['MAX_FILE_SIZE']).') specified in the HTML form';
	        case UPLOAD_ERR_PARTIAL:
	            return 'File was only partially uploaded';
	        case UPLOAD_ERR_NO_FILE:
	            return 'No file was uploaded. Please select a file.';
	        case UPLOAD_ERR_NO_TMP_DIR:
	            return 'Missing a temporary folder';
	        case UPLOAD_ERR_CANT_WRITE:
	            return 'Failed to write file to disk';
	        case UPLOAD_ERR_EXTENSION:
	            return 'File upload stopped by extension';
	        default:
	            return 'Unknown upload error';
	    }
	}
	/**
	 * Converts filesize to a more legible format (from bits to 'Byte','KB','MB','GB','TB' or 'PB' depending on the size)
	 */
	function display_filesize($filesize){
	    if(is_numeric($filesize)){
			$decr = 1024; $step = 0;
			$prefix = array('Byte','KB','MB','GB','TB','PB');
			   
			while(($filesize / $decr) > 0.9){
				$filesize = $filesize / $decr;
				$step++;
			}
			return round($filesize,2).' '.$prefix[$step];
	    } else {
			return 'NaN';
	    }
	}
	
	/**
	 * Creates a valid filename by removing special characters
	 */
	 function reformat_filename($str) {
		$allowed = "/[^a-z0-9\\-\\_\\.]/i";
		return preg_replace($allowed,"",$str);
	}


	/**
	 * This function transforms the php.ini notation for numbers (like '2M') to an integer (2*1024*1024 in this case)
	 */
	function letterToNumber($v)
	{ 
		$l = substr($v, -1);
		$ret = substr($v, 0, -1);
		switch(strtoupper($l))
		{
		case 'P':
			$ret *= 1024;
		case 'T':
			$ret *= 1024;
		case 'G':
			$ret *= 1024;
		case 'M':
			$ret *= 1024;
		case 'K':
			$ret *= 1024;
			break;
		}
		return $ret;
	}
}
?>