<?php

require_once(EP_PLUGIN_DIR.'/includes/EPConfig.php');
require_once(EP_PLUGIN_DIR.'/includes/EPItemFiles.php');

/* Prints the box content */
function exchangePlatformEditHtml() {
	
	global $post;

	// creation of the classes instances
	$epItemFiles = new EPItemFiles();
	$epItemData = new EPItemData();
	$epConfig = new EPConfig();
	
	// load config from wordpress config
	$epConfig->loadConfig();
	
	// handle errors and messages (comming from last ajax call)
	$message = $epItemData->getLastError($post->ID);
	if ($message != '')
		ep_error($message);
	$message = $epItemData->getLastMessage($post->ID);
	if ($message != '')
		ep_success($message);
	// empty the messages
	$epItemData->setLastError('',$post->ID);
	$epItemData->setLastMessage('',$post->ID);

	
	// retrieve the selected version and selected project for the current post/page
	$selectedProject = $epItemData->getSelectedProject($post->ID); 
	$selectedVersionsArray = $epItemData->getSelectedVersions($post->ID);
	$itemCurrentVersion = $epItemData->getItemCurrentVersion($post->ID);
	$currentFileName = $epItemData->getCurrentFileName($post->ID);
	$dependencies = $epItemData->getDependencies($post->ID);

	// build the HTML for the project selection drop down list
	// Use of the nonce for verification
	wp_nonce_field( plugin_basename(__FILE__), 'exchangePlatform' );
	?>
	<input type="hidden" name="postIdParam" value=<?php echo $post->ID; ?> />
	<p>
		<h4>Related project</h4>
		<select id="projects_dropdown" name="projects_dropdown" onchange="changeVersions(this.selectedIndex)">
			<OPTION VALUE="" >Project : </OPTION>
		<?php
			$selectedProjectIndex = -1;
			// default value is the selected project
			// elements of the drop down list
			for($idx=0;$idx<count($epConfig->projectArray);$idx++) {
				echo '<OPTION VALUE="'.$epConfig->projectArray[$idx].'"';
				if ($epConfig->projectArray[$idx] == $selectedProject)
				{
					$selectedProjectIndex = $idx;
					echo ' selected ';
				}
				echo '>' . $epConfig->projectArray[$idx] . '</OPTION>';
			}
		?>
		</select>
	</p>
	<script type="text/javascript"> 
	//<![CDATA[
		function changeVersions($selectedIndex) 
		{ 
			//alert($selectedIndex);
			if ($selectedIndex==0)
				changeVersionComboOptions([]);
			else
			{
				changeVersionComboOptions($versionArray[$selectedIndex-1]);
			}
		} 
		function changeVersionComboOptions($optionsArray)
		{
			$div = document.getElementById("version_combo_div");
			$div.innerHTML = '<h4>Compatibile with version</h4>';
			for ($idx = 0; $idx<$optionsArray.length; $idx++)
			{
				//alert($idx + " - "+$combo);
				var checkbox = document.createElement('input');
				checkbox.type = 'checkbox';
				checkbox.name = 'version_selection_'+$idx;
				checkbox.defaultChecked = false;
				checkbox.value = $optionsArray[$idx];
				$div.appendChild( checkbox );
		        var text = document.createTextNode( $optionsArray[$idx]);
		        $div.appendChild( text );			
				var breakElem = document.createElement("BR");
				$div.appendChild( breakElem );
		    }
		}
	
		$versionArray = [<?php
		// echo the versions into a javascript variable
		for($idx=0;$idx<count($epConfig->versionArray);$idx++) {
			$versionsForAProject = implode('","',$epConfig->versionArray[$idx]);
			echo '["'.$versionsForAProject.'"]';
			if ($idx != count($epConfig->versionArray)-1) echo ',';
		}
		// build the HTML for the version selection drop down list
		?>];
	
	//]]>
	</script> 
	<p>
		<div id="version_combo_div" name="version_combo_div">
		<h4>Compatibile with <?php echo $selectedProject; ?> version</h4>
		<?php
			$versionArrayForSelectedProject = Array();
			if ($selectedProjectIndex>=0)
				$versionArrayForSelectedProject = $epConfig->versionArray[$selectedProjectIndex];
			// elements of the drop down list
			for($idx=0;$idx<count($versionArrayForSelectedProject);$idx++) 
			{
				echo '<input type="checkbox" name="version_selection_'.$idx.'" value="'.$versionArrayForSelectedProject[$idx].'"';
				if (in_array($versionArrayForSelectedProject[$idx], $selectedVersionsArray) == true)
					echo ' checked="checked" ';
				echo '/>'.$versionArrayForSelectedProject[$idx].'<br />';
			}
		?>
		</div>
	</p>
	<p>
		<h4>Version</h4> <?php if ($currentFileName != '') echo '(re-upload file after you have changed this value)'; ?>
		<input type="text" name="item_current_version_text" value="<?php echo $itemCurrentVersion; ?>" <?php /*if ($currentFileName != '') echo 'disabled="disabled"';*/ ?> />
	</p>
	<p>
		<!-- FILE UPLOAD STUFF -->
		<?php 
			
			if ($currentFileName == '')
			{
				?>
				<h4>No file selected, Please add a file (zip)</h4>
				<?php
			}
			else
			{
				?>
				<h4>Current File</h4>
				<p><?php echo $currentFileName; ?><br /><input type="checkbox" name="epDeleteCurrentFile" /> Delete this file</p>Or Update this file:
				<?php
				if (count($dependencies) > 0)
				{
					?>
					<p>
						<h4>Depends on <?php echo count($dependencies); ?> other elements of the <?php echo $selectedProject; ?> project</h4>
						<ul>
						<?php
							for($idx=0;$idx<count($dependencies);$idx++) 
							{
								$p = get_post($dependencies[$idx]);
								echo '<li> - <a href="'.$p->guid.'">'.$p->post_title.'</a></li>';
							}
						?>
						</ul>
					</p>
					<?php
				}
			}			
		?>
		<script type="text/javascript"> 
		//<![CDATA[
			$form = document.getElementById("post");
			$form.encoding = "multipart/form-data";
		//]]>
		</script> 
		<!-- MAX_FILE_SIZE must precede the file input field -->
		<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $epItemFiles->MAX_FILE_SIZE; ?>" />
		<input name="userfile" type="file" />
		<!-- FILE UPLOAD STUFF -->
	</p>
	<?php
}

/**
 * When the post is saved, saves our custom data
 */
function exchangePlatformSavePost($post_ID)
{
	global $post;
	$post_ID = $post->ID;
	// no because of ajax	$post_ID = $_GET['post'];
	// workaround bug "wrong post id"
	//$post_ID = $_POST['postIdParam'];
	
	// creation of the EPConfig instance
	$epItemFiles = new EPItemFiles();
	$epItemData = new EPItemData();
	$epConfig = new EPConfig();
	$epConfig->loadConfig();

//	$epItemData->setSelectedVersions(array("v1.3","v1.4","v1.6"),$post_ID);
//	$epItemData->setLastError('Error while handling uploaded file',$post_ID);
//	return $post_ID;
	
	
	// verfification of the nonce because we're worthing it
	if ( !wp_verify_nonce( $_POST['exchangePlatform'], plugin_basename(__FILE__) )) {
		return $post_ID;
	}
	
	// when auto saving the options were deleted so we do that to fix it :
	if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) 
		return $post_ID;
  
	// Check permissions
	if ( 'page' == $_POST['post_type'] ) {
		if ( !current_user_can( 'edit_page', $post_ID ) )
		return $post_ID;
		
		} else {
	if ( !current_user_can( 'edit_post', $post_ID ) )
		return $post_ID;
	}
	
	// check choices
	if ($_POST['item_current_version_text'] == '' && !empty($_FILES) && $_FILES['userfile']['error'] !== UPLOAD_ERR_NO_FILE)
	{
		$epItemData->setLastError("Please provide the version of your plugin when you upload a file.<br />".$_FILES['userfile']['name']." NOT processed",$post_ID);
		return $post_ID;
	}

	// store the selections
	$selectedProject = $_POST['projects_dropdown'];
	// find the index of the selected project
	$selectedProjectIndex = -1;
	for($idx=0;$idx<count($epConfig->projectArray);$idx++)
	{
		if ($epConfig->projectArray[$idx] == $selectedProject)
		{
			$selectedProjectIndex = $idx;
			break;
		}
	}

	// current version
	$itemCurrentVersion = $_POST['item_current_version_text'];
	$epItemData->setItemCurrentVersion($itemCurrentVersion,$post_ID);
	
	// project found?
	if ($selectedProjectIndex < 0)
	{
		// display a message
		// do not work here because save is ajax :
		// > ep_error("The project $selectedProject is not defined");
		$epItemData->setLastMessage("The project $selectedProject is not defined",$post_ID);
		return $post_ID;
	}
	
	// build selected versions array
	$versionsForSelectedProjet = $epConfig->versionArray[$selectedProjectIndex];
	$selectedVersionsArray = Array();
	for($idx=0;$idx<count($versionsForSelectedProjet);$idx++)
	{
		if (isset($_POST['version_selection_'.$idx]))
			$selectedVersionsArray[] = $_POST['version_selection_'.$idx];
	}
	// save the selection
	$epItemData->setSelectedProject($selectedProject,$post_ID);
	$epItemData->setSelectedVersions($selectedVersionsArray,$post_ID);

	// file upload
	if (isset($_POST['epDeleteCurrentFile']))
	{
		// delete the file
		$epItemData->setCurrentFileName('',$post_ID);
		try
		{
			$res = $epItemFiles->removeFiles($epConfig->epSecureOfflineFolderDir,$post_ID);
		}
		catch(Exception $e)
		{
			// error
			//$test = str_replace('\\','\\\\',$_FILES['userfile']['tmp_name']);
			$epItemData->setLastError('Error catched, could not remove files for post '.$post_ID.'<br />'.$e->getMessage(),$post_ID);
			return $post_ID;
		}
		// prompt
		// do not work here because save is ajax :
		// > ep_success('File successfully deleted');
		$epItemData->setLastMessage('File successfully deleted<br />'.$res,$post_ID);
	}
	// add the file
	if (!empty($_FILES) && $_FILES['userfile']['error'] !== UPLOAD_ERR_NO_FILE)
	{
		$epItemData->setLastMessage('File upload successful for '.$_FILES['userfile']['name'],$post_ID);

		// If file was correctly uploaded
		if ($_FILES['userfile']['error'] === UPLOAD_ERR_OK)
		{
			$versionInfo = array();
			$versionInfo['version'] = $epItemData->getItemCurrentVersion($post_ID);
			$versionInfo['postID'] = $post_ID;
			$versionInfo['compatibleVersions'] = $epItemData->getSelectedVersions($post_ID);
			// handle upload
			try
			{
				$errMessage = $epItemFiles->handleUploadedFile($_FILES['userfile'],$epConfig->epSecureOfflineFolderDir, $epConfig->epAllowedFoldersArray,$versionInfo,$post_ID);
			}
			catch(Exception $e)
			{
				// error
				//$test = str_replace('\\','\\\\',$_FILES['userfile']['tmp_name']);
				$epItemData->setLastError('Error catched, could not process file '.$_FILES['userfile']['name'].'<br />'.$e->getMessage(),$post_ID);
				return $post_ID;
			}
			if ($errMessage != '')
			{
				$epItemData->setLastError('Error, could not process file '.$_FILES['userfile']['name'].'<br />'.$errMessage,$post_ID);
				return $post_ID;
			}
				
			// success
			$epItemData->setCurrentFileName($_FILES['userfile']['name'],$post_ID);
			// do not work here because save is ajax :
			// > ep_success('File successfully added');
			$epItemData->setLastMessage('File successfully uploaded and processed '.$_FILES['userfile']['name'],$post_ID);
		}
		else
			$epItemData->setLastError(file_upload_error_message($_FILES['userfile']['error']),$post_ID);
	}
	return $post_ID;
}

/* Define the custom box */
add_action('add_meta_boxes', 'exchangePlatformEditBox');

// add the selection box to the edit posts and pages
function exchangePlatformEditBox() {
	add_meta_box('exchangePlatform', EP_EDIT_PAGE_LABEL, 'exchangePlatformEditHtml', 'post', 'side', 'high'); 
	add_meta_box('exchangePlatform', EP_EDIT_PAGE_LABEL, 'exchangePlatformEditHtml', 'page', 'side', 'high');
}

/* Do something with the data entered */
add_action('save_post', exchangePlatformSavePost,10,2);
//add_filter('filesystem_method', exchangePlatformSavePost);
//exchangePlatformSavePost();

?>